#include "abrepeatdialog.h"
#include "ui_abrepeatdialog.h"
#include "abrepeater.h"

struct ABRepeatDialog::Data {
	Data(ABRepeatDialog *parent) {
		p = parent;
		repeater = ABRepeater::get();
		ui.setupUi(p);
		connect(ui.a_time_button, SIGNAL(clicked()), p, SLOT(getAFromTime()));
		connect(ui.b_time_button, SIGNAL(clicked()), p, SLOT(getBFromTime()));
		connect(ui.a_subtitle_button, SIGNAL(clicked()), p, SLOT(getAFromSubtitle()));
		connect(ui.b_subtitle_button, SIGNAL(clicked()), p, SLOT(getBFromSubtitle()));
		connect(ui.quit_button, SIGNAL(clicked()), repeater, SLOT(stop()));
		connect(ui.start_button, SIGNAL(clicked()), p, SLOT(start()));
	}
	ABRepeatDialog *p;
	Ui::Ui_ABRepeatDialog ui;
	ABRepeater *repeater;
	const QTime zero;
};

ABRepeatDialog::ABRepeatDialog(QWidget *parent)
: QDialog(parent) {
	d = new Data(this);
}

ABRepeatDialog::~ABRepeatDialog() {
	delete d;
}

void ABRepeatDialog::start() {
	int a = d->zero.msecsTo(d->ui.a_time_edit->time());
	int b = d->zero.msecsTo(d->ui.b_time_edit->time());
	int dif = static_cast<int>(d->ui.add_time_spin->value()*1000);
	d->repeater->repeat(a - dif, b+ dif, d->ui.times_spin->value());
}

void ABRepeatDialog::getAFromTime() {
	d->ui.a_time_edit->setTime(d->zero.addMSecs(d->repeater->setAToCurrentTime()));
}

void ABRepeatDialog::getAFromSubtitle() {
	d->ui.a_time_edit->setTime(d->zero.addMSecs(d->repeater->setAToSubtitleTime()));
}

void ABRepeatDialog::getBFromTime() {
	d->ui.b_time_edit->setTime(d->zero.addMSecs(d->repeater->setBToCurrentTime()));
}

void ABRepeatDialog::getBFromSubtitle() {
	d->ui.b_time_edit->setTime(d->zero.addMSecs(d->repeater->setBToSubtitleTime()));
}

