#include <QDir>
#include <QApplication>
#include <QString>
#include "helper.h"

struct Helper::Data {
	Data(Helper *parent) : p(parent) {
		appPath = QApplication::applicationDirPath();
		QDir home = QDir::home();
		homePath = home.path();
		if (!home.exists(".cmplayer"))
			home.mkdir(".cmplayer");
		privatePath = homePath + "/.cmplayer";
		configFile = privatePath + "/config.ini";
		recentFile = privatePath + "/recent.ini";
		menuFile = privatePath + "/menu.xml";
		
	}
	Helper *p;
	QString appPath;
	QString configFile;
	QString homePath;
	QString recentFile;
	QString menuFile;
	QString privatePath;
};

Helper::Helper() {
	d = new Data(this);
}

Helper::~Helper() {
	delete d;
}

const QString &Helper::privatePath() {
	return get()->d->privatePath;
}

const QString &Helper::configFile() {
	return get()->d->configFile;
}

const QString &Helper::appPath() {
	return get()->d->appPath;
}

const QString &Helper::recentFile() {
	return get()->d->recentFile;
}

const QString &Helper::menuFile() {
	return get()->d->menuFile;
}

const QString &Helper::homePath() {
	return get()->d->homePath;
}

